/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <iostream>
#include <qstring.h>
#include "colorcoding.h"

double colorCoding::f(void)
{
	double R,band1,band2,band3;
	
	R=parameters[0];
	band1=parameters[1];
	band2=parameters[2];
	band3=parameters[3];
    
	if(band1==10) band1=0.1;
	if(band2==10) band2=0.1;
	if(band3==10) band3=-1;
	R=(band1*10+band2)*pow(10,band3);
	
	return R;
}

int colorCoding::solve(int index_to_solve,double guess,SolveType solveflags)
{
	double R,band1,band2,band3;
	
	if(index_to_solve==1) 
	{
		R=parameters[0];
		band3=floor(log10(R))-1;
		if(band3<0) band3=-1; //the smallest value is -1
		band1=floor( R/pow(10,band3)*1.0/10.0 );
		if(band1==0) band1=0.1;//the smallest value is 0.1
		band2=(R-band1*10*pow(10,band3))/pow(10,band3);
		if(band2>0 && band2<1) band2=0.1;
		else band2=round(band2);
		//printf("%.0g - %.0g - %.0g -> for %g asked\n",band1,band2,band3,parameters[0]);
		if(band1==0.1) band1=10;
		if(band2==0.1) band2=10;
		if(band3<0) band3=10;	
		parameters[1]=band1;
		parameters[2]=band2;
		parameters[3]=band3;
	} //if index_to_solve==0, we go directly here
	
	R=f();
	parameters[0]=R;
	
	return EXIT_SUCCESS;
}
