/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef INDUCTANCE_H
#define INDUCTANCE_H
#include "equation.h"

/* this class is used for inductances calculations */
class inductance : public equation 
{
public:
	double L;
	double C;
	QString message;
public:
	inductance() {nb_params=6;}
	int setType(int choice);
	double f();
	void CalculateLandC();
	double parallele_wires();
	double coaxial_line();
	double strip_line();
	double converging_line();
	double disks();
	double rectangular_coil();
	double helix();
	double L2C();
	double C2L();
private:
	enum InductanceType {ParalleleWires, CoaxialLine, StripLine, ConvergingLine, Disks, RectangularCoil, Helix};
	InductanceType type;
	double Ksh(double);
	double Kl(double);
	double Ns(double);
	double Gs(double);
};
#endif
